part of wrike.test;

class TaskTest {
  static List<wrike.Account> _accounts;
  static wrike.Account _account;
  static wrike.Folder _folder;
  static wrike.Task _target;
  static run() {
    setUp(() {
      return initApi().then((_) => api.getAccounts()).then((accounts) {
        _accounts = accounts;
        _account = _accounts[0];
      }).then((_) {
        var f1 = new wrike.Folder(title: randomString(prefix: "task_title"), description: randomString(prefix: "description"));
        return api.createFolder(_account.rootFolderId, f1).then((f2) {
          _folder = f2;
        });
      });
    });
    group("Task", () {
      test("create", () {
        var t1 = new wrike.Task(title: randomString(prefix: "title"), description: randomString(prefix: "description"));
        return api.createTask(_account.rootFolderId, t1).then((t2) {
          _target = t2;
          _taskEqual(t1, t2);
          expect(1, equals(t2.sharedIds.length));
          expect(wrike.FolderScope.WsTask, equals(t2.scope));
        });
      });

      test("update", () {
        var t1 = new wrike.Task(title: randomString(prefix: "task_title"), description: randomString(prefix: "description"),status: wrike.TaskStatus.Deferred);
        return api.updateTask(_target.id, title: t1.title, status: t1.status, description: t1.description).then((t2) {
          _target = t2;
          _taskEqual(t1, t2);
          expect(t1.status, equals(t2.status));
          expect(wrike.FolderScope.WsTask, equals(t2.scope));
        });
      });

      test("delete", () {
        return api.deleteTask(_target.id).then((t2) {
          _target = t2;
          expect(wrike.FolderScope.RbTask, equals(t2.scope));
        });
      });

    });
    tearDown(() {
      if (_folder != null) {
        api.deleteFolder(_folder.id);
      }
    });
  }

  static void _taskEqual(wrike.Task f1, wrike.Task f2) {
    expect(f1.title, equals(f2.title));
    expect(f1.description, equals(f2.description));
  }
}
